Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse JDT Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.jdt.core.dom
Class TypeDeclaration

    java.lang.Object
      org.eclipse.jdt.core.dom.ASTNode
          org.eclipse.jdt.core.dom.BodyDeclaration
              org.eclipse.jdt.core.dom.AbstractTypeDeclaration
                  org.eclipse.jdt.core.dom.TypeDeclaration

public class TypeDeclaration
extends AbstractTypeDeclaration

Type declaration AST node type. A type declaration is the union of a class declaration and an interface declaration. For JLS2:

     TypeDeclaration:
     		ClassDeclaration
     		InterfaceDeclaration
     ClassDeclaration:
          [ Javadoc ] { Modifier } class Identifier
    			[ extends Type]
    			[ implements Type { , Type } ]
    			{ { ClassBodyDeclaration | ; } }
     InterfaceDeclaration:
          [ Javadoc ] { Modifier } interface Identifier
    			[ extends Type { , Type } ]
     			{ { InterfaceBodyDeclaration | ; } }

For JLS3, type parameters and reified modifiers (and annotations) were added, and the superclass type name and superinterface types names are generalized to type so that parameterized types can be referenced:

     TypeDeclaration:
     		ClassDeclaration
     		InterfaceDeclaration
     ClassDeclaration:
          [ Javadoc ] { ExtendedModifier } class Identifier
    			[ < TypeParameter { , TypeParameter } > ]
    			[ extends Type ]
    			[ implements Type { , Type } ]
    			{ { ClassBodyDeclaration | ; } }
     InterfaceDeclaration:
          [ Javadoc ] { ExtendedModifier } interface Identifier
    			[ < TypeParameter { , TypeParameter } > ]
    			[ extends Type { , Type } ]
     			{ { InterfaceBodyDeclaration | ; } }

When a Javadoc comment is present, the source range begins with the first character of the "/**" comment delimiter. When there is no Javadoc comment, the source range begins with the first character of the first modifier or annotation (if any), or the first character of the "class" or "interface" keyword (if no modifiers or annotations). The source range extends through the last character of the "}" token following the body declarations.

Since:
  2.0

Field Summary
`static ChildListPropertyDescriptor` | `BODY_DECLARATIONS_PROPERTY` The "bodyDeclarations" structural property of this node type (added in JLS3 API).
`static SimplePropertyDescriptor` | `INTERFACE_PROPERTY` The "interface" structural property of this node type.
`static ChildPropertyDescriptor` | `JAVADOC_PROPERTY` The "javadoc" structural property of this node type.
`static SimplePropertyDescriptor` | `MODIFIERS_PROPERTY` The "modifiers" structural property of this node type (JLS2 API only).
`static ChildListPropertyDescriptor` | `MODIFIERS2_PROPERTY` The "modifiers" structural property of this node type (added in JLS3 API).
`static ChildPropertyDescriptor` | `NAME_PROPERTY` The "name" structural property of this node type.
`static ChildListPropertyDescriptor` | `SUPER_INTERFACE_TYPES_PROPERTY` The "superInterfaceTypes" structural property of this node type (added in JLS3 API).
`static ChildListPropertyDescriptor` | `SUPER_INTERFACES_PROPERTY` The "superInterfaces" structural property of this node type (JLS2 API only).
`static ChildPropertyDescriptor` | `SUPERCLASS_PROPERTY` The "superclass" structural property of this node type (JLS2 API only).
`static ChildPropertyDescriptor` | `SUPERCLASS_TYPE_PROPERTY` The "superclassType" structural property of this node type (added in JLS3 API).
`static ChildListPropertyDescriptor` | `TYPE_PARAMETERS_PROPERTY` The "typeParameters" structural property of this node type (added in JLS3 API).

Fields inherited from class org.eclipse.jdt.core.dom.ASTNode
`ANNOTATION_TYPE_DECLARATION, ANNOTATION_TYPE_MEMBER_DECLARATION, ANONYMOUS_CLASS_DECLARATION, ARRAY_ACCESS, ARRAY_CREATION, ARRAY_INITIALIZER, ARRAY_TYPE, ASSERT_STATEMENT, ASSIGNMENT, BLOCK, BLOCK_COMMENT, BOOLEAN_LITERAL, BREAK_STATEMENT, CAST_EXPRESSION, CATCH_CLAUSE, CHARACTER_LITERAL, CLASS_INSTANCE_CREATION, COMPILATION_UNIT, CONDITIONAL_EXPRESSION, CONSTRUCTOR_INVOCATION, CONTINUE_STATEMENT, DO_STATEMENT, EMPTY_STATEMENT, ENHANCED_FOR_STATEMENT, ENUM_CONSTANT_DECLARATION, ENUM_DECLARATION, EXPRESSION_STATEMENT, FIELD_ACCESS, FIELD_DECLARATION, FOR_STATEMENT, IF_STATEMENT, IMPORT_DECLARATION, INFIX_EXPRESSION, INITIALIZER, INSTANCEOF_EXPRESSION, JAVADOC, LABELED_STATEMENT, LINE_COMMENT, MALFORMED, MARKER_ANNOTATION, MEMBER_REF, MEMBER_VALUE_PAIR, METHOD_DECLARATION, METHOD_INVOCATION, METHOD_REF, METHOD_REF_PARAMETER, MODIFIER, NORMAL_ANNOTATION, NULL_LITERAL, NUMBER_LITERAL, ORIGINAL, PACKAGE_DECLARATION, PARAMETERIZED_TYPE, PARENTHESIZED_EXPRESSION, POSTFIX_EXPRESSION, PREFIX_EXPRESSION, PRIMITIVE_TYPE, PROTECT, QUALIFIED_NAME, QUALIFIED_TYPE, RETURN_STATEMENT, SIMPLE_NAME, SIMPLE_TYPE, SINGLE_MEMBER_ANNOTATION, SINGLE_VARIABLE_DECLARATION, STRING_LITERAL, SUPER_CONSTRUCTOR_INVOCATION, SUPER_FIELD_ACCESS, SUPER_METHOD_INVOCATION, SWITCH_CASE, SWITCH_STATEMENT, SYNCHRONIZED_STATEMENT, TAG_ELEMENT, TEXT_ELEMENT, THIS_EXPRESSION, THROW_STATEMENT, TRY_STATEMENT, TYPE_DECLARATION, TYPE_DECLARATION_STATEMENT, TYPE_LITERAL, TYPE_PARAMETER, VARIABLE_DECLARATION_EXPRESSION, VARIABLE_DECLARATION_FRAGMENT, VARIABLE_DECLARATION_STATEMENT, WHILE_STATEMENT, WILDCARD_TYPE`

Method Summary
`FieldDeclaration[]` | `getFields()` Returns the ordered list of field declarations of this type declaration.
`MethodDeclaration[]` | `getMethods()` Returns the ordered list of method declarations of this type declaration.
`Name` | `getSuperclass()` Returns the name of the superclass declared in this type declaration, or `null` if there is none (JLS2 API only).
`Type` | `getSuperclassType()` Returns the superclass declared in this type declaration, or `null` if there is none (added in JLS3 API).
`TypeDeclaration[]` | `getTypes()` Returns the ordered list of member type declarations of this type declaration.
`boolean` | `isInterface()` Returns whether this type declaration declares a class or an interface.
`static List` | `propertyDescriptors(int apiLevel)` Returns a list of structural property descriptors for this node type.
`ITypeBinding` | `resolveBinding()` Resolves and returns the binding for the class or interface declared in this type declaration.
`void` | `setInterface(boolean isInterface)` Sets whether this type declaration declares a class or an interface.
`void` | `setSuperclass(Name superclassName)` Sets or clears the name of the superclass declared in this type declaration (JLS2 API only).
`void` | `setSuperclassType(Type superclassType)` Sets or clears the superclass declared in this type declaration (added in JLS3 API).
`List` | `superInterfaces()` Returns the live ordered list of names of superinterfaces of this type declaration (JLS2 API only).
`List` | `superInterfaceTypes()` Returns the live ordered list of superinterfaces of this type declaration (added in JLS3 API).
`List` | `typeParameters()` Returns the live ordered list of type parameters of this type declaration (added in JLS3 API).

Methods inherited from class org.eclipse.jdt.core.dom.AbstractTypeDeclaration
`bodyDeclarations, getName, isLocalTypeDeclaration, isMemberTypeDeclaration, isPackageMemberTypeDeclaration, setName`

Methods inherited from class org.eclipse.jdt.core.dom.BodyDeclaration
`getJavadoc, getModifiers, modifiers, setJavadoc, setModifiers`

Methods inherited from class org.eclipse.jdt.core.dom.ASTNode
`accept, copySubtree, copySubtrees, delete, equals, getAST, getFlags, getLength, getLocationInParent, getNodeType, getParent, getProperty, getRoot, getStartPosition, getStructuralProperty, nodeClassForType, properties, setFlags, setProperty, setSourceRange, setStructuralProperty, structuralPropertiesForType, subtreeBytes, subtreeMatch, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### JAVADOC_PROPERTY

    public static final ChildPropertyDescriptor JAVADOC_PROPERTY

  The "javadoc" structural property of this node type.

  Since:
    3.0

### MODIFIERS_PROPERTY

    public static final SimplePropertyDescriptor MODIFIERS_PROPERTY

  The "modifiers" structural property of this node type (JLS2 API only).

  Since:
    3.0

### MODIFIERS2_PROPERTY

    public static final ChildListPropertyDescriptor MODIFIERS2_PROPERTY

  The "modifiers" structural property of this node type (added in JLS3 API).

  Since:
    3.0

### INTERFACE_PROPERTY

    public static final SimplePropertyDescriptor INTERFACE_PROPERTY

  The "interface" structural property of this node type.

  Since:
    3.0

### NAME_PROPERTY

    public static final ChildPropertyDescriptor NAME_PROPERTY

  The "name" structural property of this node type.

  Since:
    3.0

### SUPERCLASS_PROPERTY

    public static final ChildPropertyDescriptor SUPERCLASS_PROPERTY

  The "superclass" structural property of this node type (JLS2 API only).

  Since:
    3.0

### SUPER_INTERFACES_PROPERTY

    public static final ChildListPropertyDescriptor SUPER_INTERFACES_PROPERTY

  The "superInterfaces" structural property of this node type (JLS2 API only).

  Since:
    3.0

### SUPERCLASS_TYPE_PROPERTY

    public static final ChildPropertyDescriptor SUPERCLASS_TYPE_PROPERTY

  The "superclassType" structural property of this node type (added in JLS3 API).

  Since:
    3.0

### SUPER_INTERFACE_TYPES_PROPERTY

    public static final ChildListPropertyDescriptor SUPER_INTERFACE_TYPES_PROPERTY

  The "superInterfaceTypes" structural property of this node type (added in JLS3 API).

  Since:
    3.0

### TYPE_PARAMETERS_PROPERTY

    public static final ChildListPropertyDescriptor TYPE_PARAMETERS_PROPERTY

  The "typeParameters" structural property of this node type (added in JLS3 API).

  Since:
    3.0

### BODY_DECLARATIONS_PROPERTY

    public static final ChildListPropertyDescriptor BODY_DECLARATIONS_PROPERTY

  The "bodyDeclarations" structural property of this node type (added in JLS3 API).

  Since:
    3.0

Method Detail

### propertyDescriptors

    public static List propertyDescriptors(int apiLevel)

  Returns a list of structural property descriptors for this node type. Clients must not modify the result.

  Parameters:
    `apiLevel` - the API level; one of the `AST.JLS*` constants
  Returns:
    a list of property descriptors (element type: `StructuralPropertyDescriptor`)
  Since:
    3.0

### isInterface

    public boolean isInterface()

  Returns whether this type declaration declares a class or an interface.

  Returns:
    `true` if this is an interface declaration, and `false` if this is a class declaration

### setInterface

    public void setInterface(boolean isInterface)

  Sets whether this type declaration declares a class or an interface.

  Parameters:
    `isInterface` - `true` if this is an interface declaration, and `false` if this is a class declaration

### typeParameters

    public List typeParameters()

  Returns the live ordered list of type parameters of this type declaration (added in JLS3 API). This list is non-empty for parameterized types.

  Note: This API element is only needed for dealing with Java code that uses new language features of J2SE 1.5. It is included in anticipation of J2SE 1.5 support, which is planned for the next release of Eclipse after 3.0, and may change slightly before reaching its final form.

  Returns:
    the live list of type parameters (element type: `TypeParameter`)
  Throws:
    `UnsupportedOperationException` - if this operation is used in a JLS2 AST
  Since:
    3.0

### getSuperclass

    public Name getSuperclass()

  Returns the name of the superclass declared in this type declaration, or `null` if there is none (JLS2 API only).

  Note that this child is not relevant for interface declarations (although it does still figure in subtree equality comparisons).

  Returns:
    the superclass name node, or `null` if there is none
  Throws:
    `UnsupportedOperationException` - if this operation is used in an AST later than JLS2

### getSuperclassType

    public Type getSuperclassType()

  Returns the superclass declared in this type declaration, or `null` if there is none (added in JLS3 API).

  Note that this child is not relevant for interface declarations (although it does still figure in subtree equality comparisons).

  Returns:
    the superclass type node, or `null` if there is none
  Throws:
    `UnsupportedOperationException` - if this operation is used in a JLS2 AST
  Since:
    3.0

### setSuperclass

    public void setSuperclass(Name superclassName)

  Sets or clears the name of the superclass declared in this type declaration (JLS2 API only).

  Note that this child is not relevant for interface declarations (although it does still figure in subtree equality comparisons).

  Parameters:
    `superclassName` - the superclass name node, or `null` if there is none
  Throws:
    `IllegalArgumentException` - if:
    - the node belongs to a different AST
    - the node already has a parent
    `UnsupportedOperationException` - if this operation is used in an AST later than JLS2

### setSuperclassType

    public void setSuperclassType(Type superclassType)

  Sets or clears the superclass declared in this type declaration (added in JLS3 API).

  Note that this child is not relevant for interface declarations (although it does still figure in subtree equality comparisons).

  Parameters:
    `superclassType` - the superclass type node, or `null` if there is none
  Throws:
    `IllegalArgumentException` - if:
    - the node belongs to a different AST
    - the node already has a parent
    `UnsupportedOperationException` - if this operation is used in a JLS2 AST
  Since:
    3.0

### superInterfaces

    public List superInterfaces()

  Returns the live ordered list of names of superinterfaces of this type declaration (JLS2 API only). For a class declaration, these are the names of the interfaces that this class implements; for an interface declaration, these are the names of the interfaces that this interface extends.

  Returns:
    the live list of interface names (element type: `Name`)
  Throws:
    `UnsupportedOperationException` - if this operation is used in an AST later than JLS2

### superInterfaceTypes

    public List superInterfaceTypes()

  Returns the live ordered list of superinterfaces of this type declaration (added in JLS3 API). For a class declaration, these are the interfaces that this class implements; for an interface declaration, these are the interfaces that this interface extends.

  Returns:
    the live list of interface types (element type: `Type`)
  Throws:
    `UnsupportedOperationException` - if this operation is used in a JLS2 AST
  Since:
    3.0

### getFields

    public FieldDeclaration[] getFields()

  Returns the ordered list of field declarations of this type declaration. For a class declaration, these are the field declarations; for an interface declaration, these are the constant declarations.

  This convenience method returns this node's body declarations with non-fields filtered out. Unlike `bodyDeclarations`, this method does not return a live result.

  Returns:
    the (possibly empty) list of field declarations

### getMethods

    public MethodDeclaration[] getMethods()

  Returns the ordered list of method declarations of this type declaration.

  This convenience method returns this node's body declarations with non-methods filtered out. Unlike `bodyDeclarations`, this method does not return a live result.

  Returns:
    the (possibly empty) list of method (and constructor) declarations

### getTypes

    public TypeDeclaration[] getTypes()

  Returns the ordered list of member type declarations of this type declaration.

  This convenience method returns this node's body declarations with non-types filtered out. Unlike `bodyDeclarations`, this method does not return a live result.

  Returns:
    the (possibly empty) list of member type declarations

### resolveBinding

    public ITypeBinding resolveBinding()

  Resolves and returns the binding for the class or interface declared in this type declaration.

  Note that bindings are generally unavailable unless requested when the AST is being built.

  Returns:
    the binding, or `null` if the binding cannot be resolved

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse JDT Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) IBM Corp. and others 2000, 2004. All Rights Reserved.